SystemOrganization addCategory: #'CS528su13-Tiki'!

Object subclass: #TikiPage
	instanceVariableNames: 'orderedLinks linkDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

TikiPage class
	instanceVariableNames: 'pageID'!

TikiPage class
	instanceVariableNames: 'pageID'!

!TikiPage class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 18:38'!
newFrom:aString
|tempPage|
tempPage:=TikiPage new.
tempPage makeLinkDictionaryFrom:aString.
^tempPage! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/3/2013 12:26'!
initialize 
linkDictionary:=Dictionary new.
orderedLinks:=OrderedCollection new.! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 18:33'!
linkDictionary
^linkDictionary! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/3/2013 12:30'!
makeLinkDictionaryFrom: aString 
|rawLinkList tempID tempText tempLength tempIndex|

rawLinkList:=aString findTokens:$#.
"linkDictionary:= Dictionary new."
orderedLinks removeAll.
(linkDictionary keys) do: [ :each |  linkDictionary removeKey: each ].

rawLinkList do: [:each | tempLength:=each size. tempIndex:=each indexOf:(Character space). tempID:=each copyFrom: 1 to: tempIndex-1. tempText:= each copyFrom: tempIndex+1 to:tempLength. orderedLinks add:tempID. linkDictionary at: (tempID asSymbol) put: tempText].
! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/3/2013 12:29'!
orderedLinks
^orderedLinks! !

WAComponent subclass: #TikiWeb
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiWeb methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 16:05'!
style 
	^'a:link {color:black; text-decoration:none}
	a:visited{color:black; text-decoration:none}
	a:hover { color:gray; text-decoration:none} 
	a:active { color:black; text-decoration:none'! !

TikiWeb subclass: #TikiWebMain
	instanceVariableNames: 'mainInput currentPage editting'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiWebMain class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:25'!
canBeRoot
^true! !

!TikiWebMain class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:48'!
initialize
	super initialize! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/3/2013 13:00'!
initialize
super initialize.
editting:=false.
mainInput:='Test input'.
"currentPage:=TikiPage newFrom:'#fruit apples bananas #pets dog cat bear'."
currentPage:=TikiPage newFrom:'#red car apple stopsign mars #blue sky ocean blueberry'.! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:43'!
mainInput
^mainInput! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:54'!
mainInput: anInput
mainInput:=anInput! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 18:23'!
processTagClick: aSymbol 
	self inform: 'You clicked on ',( aSymbol asString)! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/3/2013 13:54'!
renderContentOn: html 
		html heading: 'TextClicking '.
		html break.
		html text: mainInput asString.
		html break.
		"this doesn't update currently"
		html form:[
			editting ifTrue:[	html textInput
			on: #mainInput of: self] ifFalse:[
		(currentPage orderedLinks) do:[:each |
			html anchor
				callback: [self processTagClick: each];
				with: ((currentPage linkDictionary) at: each ifAbsent: ['(',each asString,')'] ).
			html text:' '.
			]
		].
		html break.
		html submitButton 
			callback: [ "self inform: mainInput." editting ifFalse:[editting:=true] ifTrue:[editting:=false. currentPage makeLinkDictionaryFrom: mainInput]];
			text: (editting ifTrue: ['Submit new links'] ifFalse: [ 'Start editting' ]).
			]! !
TikiWebMain initialize!
